-//-----------------------------------------------------------------------
//   20  `4`l wKR`
//                                                           PIC16F1827p
//
//                                            filename: ex20_irtx.c
//------------------------------------------------------------------------
#include <16f1827.h>
#fuses INTRC_IO,NOWDT,NOPROTECT,NOCPD,NOMCLR,NOPUT,BROWNOUT,NOIESO
#fuses NOFCMEN,PLL_SW,NOLVP,NOSTVREN,BORV25
#use delay(clock=16MHZ)					// NbNg16MHz
#use i2c(master,sda=PIN_B7,scl=PIN_B6,FORCE_SW)	// I2C̓}X^[hCSDA:RB7CSCL:RB6

#include <lcd_lib.h>					// LCDCu֐̃CN[h

#define		ON		1
#define		OFF 	0
#define		SWON	0					// XCb`ON
#define     SWOFF	1					// XCb`OFF
										// --- I2C EEPROM(24LC64)}bv
#define ADR1	0x0000					// L{^1 AhX(0x 00`0x 7F)
#define ADR2  	0x0080					// L{^2 AhX(0x 80`0x FF)
#define ADR3  	0x0100					// L{^3 AhX(0x100`0x17F)
#define ADR4  	0x0180					// L{^4 AhX(0x180`0x1FF)

//------------------------------------------------------------------------
//          I/O|[g̒`
//------------------------------------------------------------------------
#byte  RA = 0x0c						// |[gA(RA)̃AhX0x0cԒn
  #bit IRD  = RA.0						// RAbit0͐ԊOfq
  #bit LED  = RA.1						// j^pLED
  #bit TGSW = RA.2						// gOXCb`
  #bit SW1  = RA.4						// ^NgXCb`1
  #bit SW2  = RA.5						// ^NgXCb`2
  #bit SW3  = RA.6						// ^NgXCb`3
  #bit SW4  = RA.7						// ^NgXCb`4
#byte  RB = 0x0d						// |[gB(RB)̃AhX0x0dԒn

#define	 DAT	60						// ON/OFFpX̎擾f[^

//------------------------------------------------------------------------
//          e֐̒`
//------------------------------------------------------------------------
// I2Cւ̏
void write_i2crom(long address, byte data) {
   int1  status;						// 1bitϐ̒`
   i2c_start();							// X^[gRfBV̔s
   i2c_write(0xa0);						// Rg[R}h(foCXAhX0xA0)
   i2c_write(address >> 8);				// ʃAhX̏
   i2c_write(address);					// ʃAhX̏
   i2c_write(data);						// 1oCgf[^̏
   i2c_stop();							// XgbvRfBV̔s
   status = 1;
   while(status==1) {					// No ACK(1) ACK(0)܂ő҂
   	i2c_start();						// X^[gRfBV
   	status=i2c_write(0xa0);				// ACKM҂(҂)			
   }
   i2c_stop();							// XgbvRfBV̔s
 }

// I2C̃f[^ǂݏo
byte read_i2crom(long address) {
   byte data;
   i2c_start();							// X^[gRfBV̔s
   i2c_write(0xa0);						// Rg[R}h(foCXAhX:0xA0)
   i2c_write(address >> 8);				// ʃAhX̏
   i2c_write(address);					// ʃAhX̏
   i2c_start();							// X^[gRfBV
   i2c_write(0xa1);						// Rg[R}h
   data=i2c_read(0);					// 1oCgf[^ǂݏo(No ACK)
   i2c_stop();							// XgbvRfBV𔭍sďI
   return(data);
 }

void ir_tx(long mch) {					// ԊOLEDɂ鑗MC:L{^AhX
   long dton = 210, dtoff = 0;			// 38kHzgduty 50%C0%̒l
   long  rdON, rdOFF, trOFF;			// [_pXONC[_pXOFFCg[OFFԕێp
   long  cx, rx, iad;					// ON/OFFpXԗpCAhXp
   byte  i, tmp1, tmp2;					// Ɨp
   byte  txON[DAT], txOFF[DAT];			// ON/OFFԈꎞۊǗpz

	iad = mch;							// I2C-ROM̏擪AhX̃Zbg
	tmp1= read_i2crom(iad);  tmp2= read_i2crom(++iad);	// [_pXON̏ʁC8rbg̓ǂݏo
	rdON = make16(tmp1,tmp2);			// [_pXONF2oCgf[^̍č\z
	tmp1= read_i2crom(++iad); tmp2= read_i2crom(++iad);	// [_pXOFF̏ʁC8rbg̓ǂݏo
	rdOFF= make16(tmp1,tmp2);			// [_pXOFF:2oCgf[^̍č\z

	for(i=0; i < DAT; i++) {
	   txON[i] = read_i2crom(++iad);	// pXONԂ̓ǂݏo
	 }
	for(i=0; i < DAT; i++) {
	   txOFF[i] = read_i2crom(++iad);	// pXOFFԂ̓ǂݏo
	 }
	tmp1= read_i2crom(++iad);  tmp2= read_i2crom(++iad);	// g[pX̏ʁC8rbg̓ǂݏo
	trOFF = make16(tmp1,tmp2);			// 2oCgf[^̍č\z

	set_pwm3_duty(dton);				// IR-LED ON
	while(!(rdON==0)) {					// [_pXON̑o 
	  delay_us(10); rdON--;
	 }
 	set_pwm3_duty(dtoff);				// IR-LED OFF
	while(!(rdOFF==0)) { 				// [_pXOFF̑o
	  delay_us(10); rdoff--;
	 }

	for(i=0; i < DAT; i++) {			// f[^pX̑o
	   cx = txON[i]; rx = txOFF[i];
	   set_pwm3_duty(dton);				// IR-LED ON
	   while(!(cx == 0)) { 
	      delay_us(10); cx--;
	    }
 	   set_pwm3_duty(dtoff);			// IR-LED OFF
	   if(rx == 0) break;				// OFFԂ̃f[^[Ȃfor[vEo
	   while(!(rx == 0)) { 
	      delay_us(10); rx--;
	    }
	 }									// end of for()
	while(!(trOFF==0)) { 
	  delay_us(10); trOFF--;			// g[OFFԂ̑o
	 }
 }


void ir_anlz(long mch) {				// ԊOR̃f[^͂ƋLێ,:L{^AhX
   long  bon, boff, iad;				// ON/OFFԂ̌vp, AhXJE^
   long  rdON, rdOFF, trOFF;			// [_pXONC[_pXOFFCg[OFFԕێp
   byte  icnt, tmp;						// JE^CƗp
   byte  irON[DAT], irOFF[DAT];			// ON/OFFԈꎞۊǗpz

   for(icnt=0; icnt < DAT; icnt++){
	  irON[icnt] = 0; irOFF[icnt] = 0;	// z̓eI[[()
	}

	icnt = 0;							// [NA
	while(!IRD); 						// [_pXĂ܂ő҂
    while(1){
      bon = 0; LED = ON;	           		// ONpXԂ̌vCj^LED_
      while(IRD) {						// IRD0ɂȂ܂ŌJԂCwhile(IRD ==1)Ɠ
		bon++; delay_us(10);			// ONJE^+1, 10usԑ҂
	   }

      boff = 0;	LED = OFF;		        // OFFpXԂ̌vCj^LED
      while(!IRD) {						// IRD1ɂȂ܂ŌJԂCwhile(IRD ==0)Ɠ
		boff++; delay_us(10);			// OFFJE^+1, 10usԑ҂
	   }

	  if(icnt == 0) {					// Mf[^̍ŏ̓[_pX
		rdON = bon;						// [_pXON(2byte)͐p̕ϐɕێ
		rdOFF= boff;					// [_pXOFF(2byte)͐p̕ϐɕێ
		icnt++;
	   } else {
	  	irON[icnt-1] = bon;				// zONԂi[
	  	irOFF[icnt-1]= boff;			// zOFFԂi[
	    if(boff > rdON *2 ) {			// [_pXONԂ2{ȏȂg[ƔfCf[^̎擾͑ł؂
			irOFF[icnt-1] = 0;			// OFFԂ̓[NA(f[^I̍})
			trOFF = boff;				// g[OFFԂi[
			break;
		 } else {
	  		icnt++;						// TṽJE^+1
      		if((icnt-1) >= DAT) break;	// 擾f[^ɏɓB狭I
		  }
		}
	 }									// end of while(1)
	iad = mch;							// I2C-ROM̏擪AhX̃Zbg
	tmp = make8(rdON,1); write_i2crom(iad,   tmp);	// [_pXON̏8rbgoI2C-ROMɏ
	tmp = make8(rdON,0); write_i2crom(++iad, tmp);	// [_pXON̉8rbgoI2C-ROMɏ
	tmp = make8(rdOFF,1); write_i2crom(++iad, tmp);	// [_pXOFF̏8rbgoI2C-ROMɏ
	tmp = make8(rdOFF,0); write_i2crom(++iad, tmp);	// [_pXOFF̉8rbgoI2C-ROMɏ
	for(icnt=0; icnt < DAT; icnt++) {
	   write_i2crom(++iad,irON[icnt]);	// pXONԂ̋L^
	 }
	for(icnt=0; icnt < DAT; icnt++) {
	   write_i2crom(++iad,irOFF[icnt]);	// pXOFFԂ̋L^
	 }
	tmp = make8(trOFF,1); write_i2crom(++iad, tmp);	// g[OFFԂ̏8rbgoI2C-ROMɏ
	tmp = make8(trOFF,0); write_i2crom(++iad, tmp);	// g[OFFԂ̉8rbgoI2C-ROMɏ
 }

//------------------------------------------------------------------------
//          C֐
//------------------------------------------------------------------------
void main(void) {
	byte bt;
	setup_oscillator(OSC_16MHZ);		// NbN16MHzɐݒ
	setup_adc_ports(NO_ANALOGS);		// ͒[q̃AiO@\͎gȂ
	setup_timer_2(T2_DIV_BY_1,104,1);	// TMR2vXP[(1),PR2=104,PWM freq=38kHz
	setup_ccp3(CCP_PWM | CCP_TIMER2);	// CCP3W[PWM[hCPWMTMR2,o͒[qRA3

	set_tris_a(0xf5);					// RA1(LED)CRA3(CCP3)͏o,͑Sē
	set_tris_b(0x00);					// |[gB͑Sďo
	initlcd();							// LCDW[̏
	set_pwm3_duty(0);					// CCP1DCRɃf[eB̐ݒ

  while(1){
	while(TGSW == SWON) {				// L^[h
	   clr_lcd();
	   locate(0,0); outst("LN[h");
	   locate(0,1); outst("{^Z^NVeN_TC");
	   bt = 0;
	   while(bt==0) {
		 if(TGSW == SWOFF) break;		// gOXCb`OFFȂʏ탂[h
	     bt = ~RA >> 4;					// {^XCb`̊mF
		}
	   clr_lcd(); locate(0,0); outst("R{^IVel!");
				  locate(0,1); outst("Rec No.");
	   switch(bt) {
		 case 1:   outi(1); ir_anlz(ADR1);	// R{^͂ցCVA擪AhXADR1
  					break;
		 case 2:   outi(2); ir_anlz(ADR2);	// R{^͂ցCVA擪AhXADR2
  					break;
		 case 4:   outi(3); ir_anlz(ADR3);	// R{^͂ցCVA擪AhXADR3
  					break;
		 case 8:   outi(4); ir_anlz(ADR4);	// R{^͂ցCVA擪AhXADR4
  					break;
		 default: 							// case萔ɊYȂΉȂ
	    }								// end of switch()	   
    }									// end of while(TGSW)
	while(TGSW == SWOFF) {				// ʏ퓮샂[h(R{^̑M)
	   clr_lcd();
	   locate(0,0); outst("R [h");
	   bt = 0;
	   while(bt==0) {
		 if(TGSW == SWON) break;		// gOXCb`ONȂL^[h
		  bt = ~RA >> 4;				// {^XCb`̊mF
		}
	   clr_lcd(); locate(0,0); outst("Tx No.");
	   switch(bt) {
		 case 1:   outi(1); ir_tx(ADR1);	// R{^1̑o
  					break;
		 case 2:   outi(2); ir_tx(ADR2);	// R{^2̑o
  					break;
		 case 4:   outi(3); ir_tx(ADR3);	// R{^3̑o
  					break;
		 case 8:   outi(4); ir_tx(ADR4);	// R{^4̑o
  					break;
		 default: 							// case萔ɊYȂΉȂ
	    }								// end of switch()	   
	}									// end of while(TGSW)
  }										// end of while(1)
 }										// end of main()
