//------------------------------------------------------------------------
//   21  GnXgPWM[h `Single PWMɂg`ó`
//           ECCP1o:P1A(RB0),P1B(RB5),P1C(RB6),P1D(RB7)
//                    [PWMg:1kHzCf[eB:50%, ANeBuHigh]
//           ECCP2o:P2A(RA7),P2B(RA6)
//                    [PWMg:10kHzCf[eB:30%, ANeBuHigh]
//                                                 filename: ex21_pwmsig.c
//------------------------------------------------------------------------
#include <16f1827.h>
#fuses INTRC_IO,NOWDT,NOPROTECT,NOCPD,NOMCLR,NOPUT,BROWNOUT,NOIESO
#fuses NOFCMEN,PLL_SW,NOLVP,NOSTVREN,BORV25
#use delay(clock=8MHZ)					// NbNg8MHz

//------------------------------------------------------------------------
//          I/O|[g̒`
//------------------------------------------------------------------------
#byte  RA = 0x0c						// |[gA(RA)̃AhX0x0cԒn
#byte  RB = 0x0d						// |[gB(RB)̃AhX0x0dԒn

#byte  PSTR1CON = 0x296					// PWMXeAO1 Rg[WX^
 #bit  P1A = PSTR1CON.0					// XeAO Cl[urbgA(P1A)
 #bit  P1B = PSTR1CON.1					// XeAO Cl[urbgB(P1B)
 #bit  P1C = PSTR1CON.2					// XeAO Cl[urbgC(P1C)
 #bit  P1D = PSTR1CON.3					// XeAO Cl[urbgD(P1D)

#byte  PSTR2CON = 0x29d					// PWMXeAO2 Rg[WX^
 #bit  P2A = PSTR2CON.0					// XeAO Cl[urbgA(P2A)
 #bit  P2B = PSTR2CON.1					// XeAO Cl[urbgB(P2B)

//------------------------------------------------------------------------
//          C֐
//------------------------------------------------------------------------
void main(void) {
	long dt1, dt2;						// f[eBTCNp
	setup_oscillator(OSC_8MHZ);			// NbN8MHzɐݒ

	setup_timer_2(T2_DIV_BY_16,124,1);	// TMR2vXP[(16),PR2=124,PWMg=1kHz
	setup_timer_4(T4_DIV_BY_1, 199,1);	// TMR4vXP[(1) ,PR4=199,PWMg=10kHz

	setup_ccp1(CCP_PWM_H_H | CCP_TIMER2 | CCP_P1A_B0 | CCP_P1C_B6 | CCP_P1D_B7);
										// ECCP1:Single PWM, d[q̑I:P1A(RB0)CP1C(RB6)CP1D(RB7)
	P1A = 1;  P1B = 1;					// PWMXeAO1Rg[WX^ɂP1A,P1BoON
	P1C = 1;  P1D = 1;					//                             P1C,P1DoON

	setup_ccp2(CCP_PWM_L_L | CCP_TIMER4 | CCP2_A7 | CCP_P2B_A6);
										// ECCP2:Single PWM, d[q̑I:P2A(RA7)CP2B(RA6)
	P2A = 1;  P2B = 1;					// PWMXeAO2Rg[WX^ɂP2A,P2BoON

	set_tris_a(0x00);					// |[gA͑Sďo
	set_tris_b(0x00);					// |[gB͑Sďo
	
	dt1 = 250;							// PWM1 duty50%,(duty(max)=500)
	dt2 = 240;							// PWM2 duty30%,(duty(max)=800)
	set_pwm1_duty(dt1);					// PWM1f[eBݒ
	set_pwm2_duty(dt2);					// PWM2f[eBݒ

	while(1);
 }
